import { onPageLoadInitAuth, post } from '@/utils/https';
import { getAuthInfo, getDataSet, toArray } from '@/utils/util';

Page({
  /**
   * 页面的初始数据
   */
  data: {
    list: [] as any[],
    authInfo: {} as any,
  },
  handleLogin(e: any) {
    this.setData({ isLogin: e.detail });
    if (e.detail) {
      this.init();
      this.getList();
    }
  },
  init() {
    this.setData({ authInfo: getAuthInfo() });
  },
  getList() {
    return new Promise<void>((resolve, reject) => {
      post('CompanyProcessV2/getParentProcess')
        .then((res: any) => {
          this.setData({ list: toArray(res.data), isLogin: true });
          resolve(res);
        })
        .catch((res) => {
          this.setData({ isLogin: false });
          reject(res);
        });
    });
  },
  onChildProcess(e: any) {
    const data = getDataSet(e);
    const index = data.index;
    const item = this.data.list[index];
    wx.navigateTo({
      url: `/pages/base/processChildConfig/processChildConfig?process_id=${
        item.process_id
      }&title=${encodeURIComponent(`${item.process_name} 工序`)}`,
    });
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(_options) {
    onPageLoadInitAuth(this, () => this.getList());
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {},

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {},

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {},

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {},

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {},

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {},

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {},
});
